// https://observablehq.com/@omkarpat/kg-covid-19-visualization@1129
import define1 from "./e93997d5089d7165@2286.js";
import define2 from "./b4b821d169d4ff8e@263.js";

export default function define(runtime, observer) {
  const main = runtime.module();
  const fileAttachments = new Map([["acetaminophen-test@2.json",new URL("./files/273bd1b8f55fcb17cd37e46bf4542605f494b460b09d2994925d67ea79c7eba4ac1c7d6e9c41777e4c0f85e23a79e793281a03d93c46f44a80fdd29e7a36f54f",import.meta.url)],["albuterol.json",new URL("./files/ec86fd860bfe15502d001407efd06d325da7640440c4ac34c40276fe208cc0192e54ad5b68b54200b54d98fb42f6dbadd0f5c4b6478bfa90a29cf79c3ad4ef05",import.meta.url)],["node_categories.csv",new URL("./files/bb73380295e0fb0d98b25b043571fc0a058e8a0a27ba92893492ea62c8b9dcb72981559aa69618ae2880ec94ccd5790600c7b80cce39a977121fba2a5963140e",import.meta.url)],["nodes_provided_by.csv",new URL("./files/f4462a43f3275fa73c01a2c7c3fce7900f63110cee7b1c691709b81af3f478f59a63cf7d191afbd980db69eaaf3f566acd853b802204ead65f5011ec3cce45c6",import.meta.url)],["edges_edge_label.csv",new URL("./files/078fc2e1b3fe5ba3a1029742b398e09078458774906a84a9a5511cfae1cdaafb7fe411718810cd1357bf98946b74d77bdd853703056f5acb02070d7c30e51ea5",import.meta.url)],["acetaminophen-big.json",new URL("./files/6b80ade132def87894b0fb35038177cfe1b6beb5a4dfe6db0baadc51b9a8e7d849e92c79e7ffde042f152ffca27a8cba54952a625aa3b847fd135cf4b93b57ed",import.meta.url)],["ubql1_human.json",new URL("./files/b3c907fff4e95281b825e9531047fd95fb20ddafeb62df37e7a09a6520dcd7591e65cd7496d02d1af1eb8238b60202d1c9dbdf0cc8d5af2afb1128243d52ce68",import.meta.url)],["ubql1_human_small@1.json",new URL("./files/73ec51a33ac5900baa23fbc692faf3ab989a69f8cb68096c03e199b11ab4b330b6d190068d3f2e44f6d1f82b4124ffe85afaa5cb3051adc577ddd5551b662c18",import.meta.url)],["edges_provided_by (1).csv",new URL("./files/c16850734d9ca57a8b29e29d36a8c72f7458bce8e35be619f90f6364c076e4cb4ebea8461e9ec9f71c34c3ad30c36596d1ba8b89b3f3461ebfa74e06cdd5a940",import.meta.url)],["edges_association_type@1.csv",new URL("./files/0924829182cf9f618abbdc0842acb5e063ee9fe69b645c5187c375641d06bf6a4c1a8988c469c307063e7fad9272f46234bdc2c26f94ad980fd004e60421fafc",import.meta.url)],["edges_target_type@1.csv",new URL("./files/79702da8cc5a2a423b73e94c15921c49dedd6c50bd9ec43db1d4bd28e72c49c7c04dc28d9a5de1c35a30a347063cbc1ad8fcdba7df4aeccdd45217647afac2cf",import.meta.url)],["nodes_node_type.csv",new URL("./files/afc635304a03412be54da3cde30b916426500594776b86285da68b998d151ff980ff66e01deb20a9310d87f9b3f31d061e5b617adc8ec34186c9c48302e06538",import.meta.url)]]);
  main.builtin("FileAttachment", runtime.fileAttachments(name => fileAttachments.get(name)));
  main.variable(observer()).define(["md"], function(md){return(
md`# KG-COVID-19 Visualization`
)});
  main.variable(observer()).define(["md"], function(md){return(
md` This notebook is only the visualization component of the [COVID Medical Document Visual Aid](https://github.com/omkarpat/COVID-Medical-Document-Visual-Aid) project. It is to be used in conjunction with the [KG-COVID-19 Data File Generator](https://github.com/omkarpat/COVID-Medical-Document-Visual-Aid/blob/main/KG_COVID_19_Data_File_Generator.ipynb) Notebook given in the project. The generated files must be uploaded here and added to 'bubble_chart_files' or 'force_graph_files' variable inorder to be accessible.
`
)});
  main.variable(observer()).define(["md"], function(md){return(
md`## Bubble Chart

Bubble charts are non-hierarchical [packed circles](/@d3/circle-packing). The area of each circle is proportional its value (here, number of examples). The organic appearance of these diagrams can be intriguing, but also consider a humble [bar chart](/@d3/horizontal-bar-chart) shown at the bottom.

I use them to visualize the categorical attributes in my data to give a macroscopic view of the organization of the dataset before diving further into a microscopic (node level) graph analysis.`
)});
  main.variable(observer("viewof bubble_chart_selection")).define("viewof bubble_chart_selection", ["select","bubble_chart_files"], function(select,bubble_chart_files){return(
select({
  description: "Select Data File",
  options: Object.keys(bubble_chart_files),
  value: "nodes_provided_by.csv"
})
)});
  main.variable(observer("bubble_chart_selection")).define("bubble_chart_selection", ["Generators", "viewof bubble_chart_selection"], (G, _) => G.input(_));
  main.variable(observer("bubble_chart")).define("bubble_chart", ["bubble_chart_pack","bubble_chart_data","d3_6","bubble_chart_width","bubble_chart_height","DOM","bubble_chart_color","bubble_chart_format"], function(bubble_chart_pack,bubble_chart_data,d3_6,bubble_chart_width,bubble_chart_height,DOM,bubble_chart_color,bubble_chart_format)
{
  const root = bubble_chart_pack(bubble_chart_data);
  
  const svg = d3_6.create("svg")
      .attr("viewBox", [0, 0, bubble_chart_width, bubble_chart_height])
      .attr("font-size", 10)
      .attr("font-family", "sans-serif")
      .attr("text-anchor", "middle");

  const leaf = svg.selectAll("g")
    .data(root.leaves())
    .join("g")
      .attr("transform", d => `translate(${d.x + 1},${d.y + 1})`);

  leaf.append("circle")
      .attr("id", d => (d.leafUid = DOM.uid("leaf")).id)
      .attr("r", d => d.r)
      .attr("fill-opacity", 0.7)
      .attr("fill", d => bubble_chart_color(d.data.name));

  leaf.append("clipPath")
      .attr("id", d => (d.clipUid = DOM.uid("clip")).id)
    .append("use")
      .attr("xlink:href", d => d.leafUid.href);

  leaf.append("text")
      .attr("clip-path", d => d.clipUid)
    .selectAll("tspan")
    .data(d => d.data.name.split(/(?=[A-Z][a-z])|\s+/g))
    .join("tspan")
      .attr("x", 0)
      .attr("y", (d, i, nodes) => `${i - nodes.length / 2 + 0.8}em`)
      .text(d => d);

  leaf.append("title")
      .text(d => `${d.data.title === undefined ? "" : `${d.data.title}
`}${bubble_chart_format(d.value)}`);
  
  return svg.node();
}
);
  main.variable(observer("bar_chart")).define("bar_chart", ["d3_6","bar_width","bar_height","bubble_chart_data","bubble_chart_color","bar_x","bar_y","bar_xAxis","bar_yAxis"], function(d3_6,bar_width,bar_height,bubble_chart_data,bubble_chart_color,bar_x,bar_y,bar_xAxis,bar_yAxis)
{
  const svg = d3_6.create("svg")
      .attr("viewBox", [0, 0, bar_width, bar_height]);

   // keep track of if tooltip is hidden or not
  var isTooltipHidden = true;
  
  // Add a tooltip div. Here I define the general feature of the tooltip: stuff that do not depend on the data point.
  // Its opacity is set to 0: we don't see it by default.
  var tooltip = d3_6.select("#my_dataviz")
    .append("div")
    .style("opacity", 0)
    .attr("class", "tooltip")
    .style("background-color", "black")
    .style("color", "white")
    .style("border-radius", "5px")
    .style("padding", "10px")

  // A function that change this tooltip when the user hover a point.
  // Its opacity is set to 1: we can now see it. Plus it set the text and position of tooltip depending on the datapoint (d)
  var showTooltip = function(d) {
    tooltip
      .transition()
      .duration(100)
      .style("opacity", 1)
    tooltip
      .html(d.x + " - " + d.y)
      .style("left", (d3_6.mouse(this)[0]+20) + "px")
      .style("top", (d3_6.mouse(this)[1]) + "px")
  }
  var moveTooltip = function(d) {
    tooltip
    .style("left", (d3_6.mouse(this)[0]+20) + "px")
    .style("top", (d3_6.mouse(this)[1]) + "px")
  }
  // A function that change this tooltip when the leaves a point: just need to set opacity to 0 again
  var hideTooltip = function(d) {
    tooltip
      .transition()
      .duration(100)
      .style("opacity", 0)
  }

  
  svg.append("g")
    .selectAll("rect")
    .data(bubble_chart_data)
    .enter().append("rect")
      .attr("fill", (d, i) => bubble_chart_color(i))
      .attr("x", (d, i) => bar_x(i))
      .attr("y", d => bar_y(d.value))
      .attr("height", d => bar_y(0) - bar_y(d.value))
      .attr("width", bar_x.bandwidth())
      // Show tooltip on hover
      .on("mouseover", showTooltip )
      .on("mousemove", moveTooltip )
      .on("mouseleave", hideTooltip )



  svg.append("g")
      .call(bar_xAxis)
      .selectAll("text")
      .style("font-size", "13px")
      .style("text-anchor", "end")
      .attr("dx", "-0.8em")
      .attr("dy", ".15em")
      .attr("transform", "rotate(-30)");

  svg.append("g")
      .call(bar_yAxis)
      .style("font-size", "13px");

  return svg.node();
}
);
  main.variable(observer()).define(["md"], function(md){return(
md`## Force-Directed Graph

Enter the data file to load`
)});
  main.variable(observer()).define(["md"], function(md){return(
md`This graph can be used to do exploratory analysis of all the edges matching the original node and their next order nodes. 

Degree of the next order nodes can be controlled using the depth attribute of the file generation function.`
)});
  main.variable(observer("viewof force_graph_selection")).define("viewof force_graph_selection", ["select","force_graph_files"], function(select,force_graph_files){return(
select({
  description: "Select Data File",
  options: Object.keys(force_graph_files),
  value: "ubql1_human_small@1.json"
})
)});
  main.variable(observer("force_graph_selection")).define("force_graph_selection", ["Generators", "viewof force_graph_selection"], (G, _) => G.input(_));
  main.variable(observer("viewof nodes_checkbox")).define("viewof nodes_checkbox", ["checkbox"], function(checkbox){return(
checkbox({
  title: "Kind of Nodes",
  description: "Please select all the kinds of nodes you wanna include",
  options: [
    { value: "biolink:AnatomicalEntity", label: "Anatomical Entity", color: "gold" },
    { value: "biolink:BiologicalProcess", label: "Biological Process", color: "blue" },
    { value: "biolink:Cell", label: "Cell", color: "green" },
    { value: "biolink:CellularComponent", label: "Cellular Component", color: "yellow" },
    { value: "biolink:ChemicalSubstance", label: "Chemical Substance", color: "violet" },
    { value: "biolink:Disease", label: "Disease", color: "grey" },
    { value: "biolink:Drug", label: "Drug", color: "darkgreen" },
    { value: "biolink:Gene", label: "Gene", color: "pink" },
    { value: "biolink:MolecularActivity", label: "Molecular Activity", color: "brown" },
    { value: "biolink:MolecularEntity", label: "Molecular Entity", color: "slateblue" },
    { value: "biolink:NamedThing", label: "Named Thing", color: "olive" },
    { value: "biolink:OntologyClass", label: "Ontology Class", color: "orange" },
    { value: "biolink:OrganismalEntity", label: "Organismal Entity", color: "lightblue" },
    { value: "biolink:PhenotypicFeature", label: "Phenotypic Feature", color: "lightgreen" },
    { value: "biolink:Protein", label: "Protein", color: "maroon" },
    { value: "biolink:Publication", label: "Publication", color: "purple" },
    { value: "biolink:RNA", label: "RNA", color: "black" },
    { value: "biolink:SequenceFeature", label: "Sequence Feature", color: "red" },
    { value: "organism taxon", label: "Organism Taxon", color: "darkgreen" }
  ],
  value: ["biolink:AnatomicalEntity", "biolink:BiologicalProcess", "biolink:Cell", "biolink:CellularComponent", "biolink:ChemicalSubstance", "biolink:Disease", "biolink:Drug", "biolink:Gene", "biolink:MolecularActivity", "biolink:MolecularEntity", "biolink:NamedThing", "biolink:OntologyClass", "biolink:OrganismalEntity", "biolink:PhenotypicFeature", "biolink:Protein", "biolink:Publication", "biolink:RNA", "biolink:SequenceFeature", "organism taxon"]
})
)});
  main.variable(observer("nodes_checkbox")).define("nodes_checkbox", ["Generators", "viewof nodes_checkbox"], (G, _) => G.input(_));
  main.variable(observer("viewof edges_checkbox")).define("viewof edges_checkbox", ["checkbox"], function(checkbox){return(
checkbox({
  title: "Kind of Edges",
  description: "Please select all the kinds of edges you wanna include",
  options: [ 
    { value: "biolink:enabled_by", label: "Enabled By", color: "gold" },
    { value: "biolink:has_gene_product", label: "Has Gene Product", color: "blue" },
    { value: "biolink:has_input", label: "Has Input", color: "green" },
    { value: "biolink:has_part", label: "Has Part", color: "yellow" },
    { value: "biolink:interacts_with", label: "Interacts With", color: "violet" },
    { value: "biolink:negatively_regulates_process_to_process", label: "Negatively Regulates Process to Process", color: "grey" },
    { value: "biolink:part_of", label: "Part Of", color: "darkgreen" },
    { value: "biolink:regulates_process_to_process", label: "Regulates Process to Process", color: "pink" },
    { value: "biolink:related_to", label: "Related To", color: "brown" }
  ],
  value: ["biolink:enabled_by", "biolink:has_gene_product", "biolink:has_input", "biolink:has_part", "biolink:interacts_with", "biolink:negatively_regulates_process_to_process", "biolink:part_of", "biolink:regulates_process_to_process", "biolink:related_to"]
})
)});
  main.variable(observer("edges_checkbox")).define("edges_checkbox", ["Generators", "viewof edges_checkbox"], (G, _) => G.input(_));
  main.variable(observer("viewof sources_checkbox")).define("viewof sources_checkbox", ["checkbox"], function(checkbox){return(
checkbox({
  title: "Sources",
  description: "Please select all the data sources you wanna include",
  options: [ 
    { value: "ChEMBL SARS-CoV-2 subset", label: "ChEMBL", color: "gold" },
    { value: "STRING", label: "STRING", color: "blue" },
    { value: "SciBite-CORD-19", label: "SciBite-CORD-19", color: "green" },
    { value: "drug_central", label: "Drug Central", color: "yellow" },
    { value: "gene-ontology", label: "Gene Ontology", color: "violet" },
    { value: "go-cams", label: "Go-cams", color: "grey" },
    { value: "go-plus", label: "Go-plus", color: "darkgreen" },
    { value: "hp", label: "HP", color: "pink" },
    { value: "intact", label: "Intact", color: "brown" },
    { value: "mondo", label: "Mondo", color: "slateblue" },
    { value: "mondo-ontology", label: "Mondo-ontology", color: "olive" },
    { value: "pharmgkb", label: "Pharmgkb", color: "orange" },
    { value: "sars_cov_2_gene_annot", label: "SARS CoV 2 Gene Annotation", color: "lightblue" },
    { value: "ttd", label: "TTD", color: "lightgreen" },
    { value: "zhou_host_proteins", label: "Zhou Host Proteins", color: "maroon" },
    { value: "NCBI", label: "NCBI", color: "purple" }
  ],
  value: ["ChEMBL SARS-CoV-2 subset", "STRING", "SciBite-CORD-19", "drug_central", "gene-ontology", "go-cams", "go-plus", "hp", "intact", "mondo", "mondo-ontology", "pharmgkb", "sars_cov_2_gene_annot", "ttd", "zhou_host_proteins", "NCBI"]
})
)});
  main.variable(observer("sources_checkbox")).define("sources_checkbox", ["Generators", "viewof sources_checkbox"], (G, _) => G.input(_));
  main.variable(observer("chart")).define("chart", ["force_graph_data","sources_checkbox","nodes_checkbox","edges_checkbox","d3","width","height","color","drag","mutable search_term","invalidation"], function(force_graph_data,sources_checkbox,nodes_checkbox,edges_checkbox,d3,width,height,color,drag,$0,invalidation)
{

  
  var links = force_graph_data.links.map(d => Object.create(d));
  var nodes = force_graph_data.nodes.map(d => Object.create(d));
  
  nodes = nodes.filter(function (node) {
    const provided_bys = node.provided_by.split('|');
    // Filter the returned array based on specified filters
    return provided_bys.some((feild) => sources_checkbox.includes(feild)); 
  });
  
  nodes = nodes.filter(function (node) {
    const groups = node.group.split('|');
    // Filter the returned array based on specified filters
    return groups.some((feild) => nodes_checkbox.includes(feild)); 
  });
  
  links = links.filter(function (link) {
    const provided_bys = link.provided_by.split('|');
    // Filter the returned array based on specified filters
    return provided_bys.some((feild) => sources_checkbox.includes(feild)) && edges_checkbox.includes(link.value) && nodes.find(node => node.id === link.source) !== undefined && nodes.find(node => node.id === link.target) !== undefined; 
  });
  
  const groups = d3.set(nodes.map(function(d){return d.group})).values();
  
  // keep track of if tooltip is hidden or not
  var isTooltipHidden = true;
  
  const simulation = d3.forceSimulation(nodes)
      .force("link", d3.forceLink(links).id(d => d.id))
      .force("charge", d3.forceManyBody())
      .force("center", d3.forceCenter(width / 2, height / 2));

  const svg = d3.create("svg")
      .attr("viewBox", [0, 0, width, height]);
  
  let g = svg.append("g")

  
  const link = g.append("g")
      .attr("stroke", "#999")
      .attr("stroke-opacity", 0.6)
    .selectAll("line")
    .data(links)
    .join("line")
      .attr("stroke-width", d => Math.sqrt(d.value))
    .on("click", clickLink);

  const node = g.append("g")
      .attr("stroke", "#fff")
      .attr("stroke-width", 1.5)
    .selectAll("circle")
    .data(nodes)
    .join("circle")
      .attr("r", 7)
      .attr("fill", color)
      .call(drag(simulation))
      .on("click", clickNode);

  function clickNode(node) {
       $0.value = node.name
       // update visibility
       isTooltipHidden = !isTooltipHidden;
       var visibility = (isTooltipHidden) ? "hidden" : "visible";

       // load tooltip content (if it changes based on node)
       loadNodeTooltipContent(node);
       
       if (isTooltipHidden) {
         unPinNode(node);
       }
    
       // place tooltip where cursor was
       return tooltip.style("top", (d3.event.pageY -10) + "px").style("left", (d3.event.pageX + 10) + "px").style("visibility", visibility);
  }
  
  function clickLink(link) {
       // update visibility
       isTooltipHidden = !isTooltipHidden;
       var visibility = (isTooltipHidden) ? "hidden" : "visible";

       // load tooltip content (if it changes based on node)
       loadLinkTooltipContent(link);
       
       if (isTooltipHidden) {
         unPinLink(link);
       }
    
       // place tooltip where cursor was
       return tooltip.style("top", (d3.event.pageY -10) + "px").style("left", (d3.event.pageX + 10) + "px").style("visibility", visibility);
  }
  
  // reset nodes to not be pinned
  function unPinNode(node) {
     node.fx = null;
     node.fy = null;
  }
  
// reset nodes to not be pinned
  function unPinLink(link) {
     node.fx = null;
     node.fy = null;
  }

  // add html content to tooltip
  function loadNodeTooltipContent(node) {
      var htmlContent = "<div>";
      htmlContent += `<h4>Name:  <a href="https://wikipedia.org/wiki/${node.name}">${node.name} </a><\/h4>`
      htmlContent += "<h4>Category: " + node.group + "<\/h4>"
      
      if(node.id.includes("PHARMGKB:")){
        const cleaned_id = node.id.replace("PHARMGKB:","");
        htmlContent += `<h4>Id: <a href="https://www.pharmgkb.org/chemical/${cleaned_id}">${node.id} </a><\/h4>`
      }
      else if(node.id.includes("UniProtKB:")){
        const cleaned_id = node.id.replace("UniProtKB:","");
        htmlContent += `<h4>Id: <a href="https://www.uniprot.org/uniprot/${cleaned_id}">${node.id} </a><\/h4>`
      }
      else if(node.id.includes("HP:")){
        htmlContent += `<h4>Id: <a href="https://hpo.jax.org/app/browse/term/${node.id}">${node.id} </a><\/h4>`
      }
      else if(node.id.includes("GO:")){
        htmlContent += `<h4>Id: <a href="http://amigo.geneontology.org/amigo/term/${node.id}">${node.id} </a><\/h4>`
      }
      else if(node.id.includes("ttd.drug:")){
        const cleaned_id = node.id.replace("ttd.drug:","");
        htmlContent += `<h4>Id: <a href="http://db.idrblab.net/ttd/data/drug/details/${cleaned_id}">${node.id} </a><\/h4>`
      }
      else if(node.id.includes("CHEBI:")){
        const cleaned_id = node.id.replace("CHEBI:","");
        htmlContent += `<h4>Id: <a href="https://www.ebi.ac.uk/chebi/searchId.do?chebiId=${cleaned_id}">${node.id} </a><\/h4>`
      }
      else if(node.id.includes("CHEMBL.COMPOUND:")){
        const cleaned_id = node.id.replace("CHEMBL.COMPOUND:","");
        htmlContent += `<h4>Id: <a href="https://www.ebi.ac.uk/chembl/compound_report_card/${cleaned_id}">${node.id} </a><\/h4>`
      }
      else if(node.id.includes("NCBITaxon:")){
        const cleaned_id = node.id.replace("NCBITaxon:","");
        htmlContent += `<h4>Id: <a href="https://www.ncbi.nlm.nih.gov/Taxonomy/Browser/wwwtax.cgi?id=${cleaned_id}">${node.id} </a><\/h4>`
      }
    
      else{
        htmlContent += "<h4> Id: "  + node.id + "<\/h4>"
      }
      htmlContent += "<h4>Provided By: " + node.provided_by + "<\/h4>"
      htmlContent += "<\/div>"
      tooltip.html(htmlContent);
  }
  
  function loadLinkTooltipContent(link) {
    var htmlContent = "<div>";
    htmlContent += `<h4>Link Type: ${link.value}<\/h4>`
    htmlContent += `<h4>Source: ${link.source.name}<\/h4>`
    htmlContent += `<h4>Target: ${link.target.name}<\/h4>`
    htmlContent += `<h4> Relation: ${link.relation}<\/h4>`
    htmlContent += `<h4>Provided By: ${link.provided_by}<\/h4>`
    if(link.publication !== ""){
      const clean_publication = link.publication.replace(":","");
      htmlContent += `<h4>Publication: <a href="https://europepmc.org/article/med/${clean_publication}">${clean_publication} </a><\/h4>`
    }
    htmlContent += "<\/div>"
    tooltip.html(htmlContent);
  }
  
  // add tooltip to HTML body
  var tooltip = d3.select("body")
    .append("div")
    .attr("class", "tooltip")
    .style("position", "absolute")
    .style("padding", "10px")
    .style("z-index", "10")
    .style("width", "300px")
    .style("height", "200px")
    .style("background-color", "rgba(230, 242, 255, 0.8)")
    .style("border-radius", "5px")
    .style("visibility", "hidden")
    .text("");
  
    node.append("title")
      .text(d => d.name);
  
  simulation.on("tick", () => {
    link
        .attr("x1", d => d.source.x)
        .attr("y1", d => d.source.y)
        .attr("x2", d => d.target.x)
        .attr("y2", d => d.target.y);

    node
        .attr("cx", d => d.x)
        .attr("cy", d => d.y);
  });

  //add zoom capabilities
  let zoomHandler = d3.zoom()
    .on("zoom",zoomAction);

  //Zoom functions
  function zoomAction(){
    g.attr("transform", `translate(${width / 2+ d3.event.transform.x}, ${height / 2+ d3.event.transform.y })`+ "scale(" + d3.event.transform.k + ")");
    }
    zoomHandler(svg);
  
  invalidation.then(() => simulation.stop());
  
  // Usually you have a color scale in your chart already
//   var color = d3.scaleOrdinal()
//     .domain(groups)
//     .range(d3.schemeSet2);
//   // Add one dot in the legend for each name.
//   g.selectAll("mydots")
//   .data(groups)
//   .enter()
//   .append("circle")
//     .attr("cx", 100)
//     .attr("cy", function(d,i){ return 100 + i*25}) // 100 is where the first dot appears. 25 is the distance between dots
//     .attr("r", 7)
//     .style("fill", function(d){ return color(d)})

//   // Add one dot in the legend for each name.
//   g.selectAll("mylabels")
//     .data(groups)
//     .enter()
//     .append("text")
//       .attr("x", 120)
//       .attr("y", function(d,i){ return 100 + i*25}) // 100 is where the first dot appears. 25 is the distance between dots
//       .style("fill", function(d){ return color(d)})
//       .text(function(d){ return d})
//       .attr("text-anchor", "left")
//       .style("alignment-baseline", "middle")

  return svg.node();
}
);
  main.variable(observer("viewof id")).define("viewof id", ["text","URLSearchParams","location","search_term"], function(text,URLSearchParams,location,search_term){return(
text({
  title: 'Wikipedia article',
  //
  placeholder: "Placeholder text",
  value: (
    new URLSearchParams(location.search).get("id") || search_term
  ).replace(/_/g, ' '),
  description: "Title or https://wikipedia.org/wiki/...",
  submit: "Go"
})
)});
  main.variable(observer("id")).define("id", ["Generators", "viewof id"], (G, _) => G.input(_));
  main.variable(observer("viewof graph")).define("viewof graph", ["dot","id","edges","wrapText","cleanId"], function(dot,id,edges,wrapText,cleanId){return(
dot`digraph "${id}" {
  outputorder=edgesfirst
  graph[rankdir=LR, center=true]
  node[shape=none, fontname="Source Serif Pro", fontsize=13]
  edge[arrowsize=0.6, arrowhead=vee, color=gray]
  ${Array.from(
    new Set(edges.map(([i, o]) => i).concat(edges.map(([i, o]) => o)))
  )
    .map(
      id =>
        `"${wrapText(id)}"[URL="?id=${cleanId(
          id
        )}", fontcolor="#3182bd", target="_top"]`
    )
    .join('\n')}
${edges.map(([i, o]) => `"${wrapText(i)}" -> "${wrapText(o)}"`).join("\n")}
}`
)});
  main.variable(observer("graph")).define("graph", ["Generators", "viewof graph"], (G, _) => G.input(_));
  main.variable(observer()).define(["domsToDiv","pick","articles"], function(domsToDiv,pick,articles){return(
domsToDiv(pick(articles, 'intro'))
)});
  main.variable(observer()).define(["md"], function(md){return(
md`# Appendix`
)});
  main.variable(observer()).define(["md"], function(md){return(
md` ### Imports`
)});
  const child1 = runtime.module(define1);
  main.import("input", child1);
  main.import("select", child1);
  main.import("text", child1);
  const child2 = runtime.module(define2);
  main.import("log", child2);
  main.import("logTail", child2);
  main.variable(observer("checkbox")).define("checkbox", ["input","html","d3_6"], function(input,html,d3_6){return(
function checkbox(config = {}) {
  let { value: formValue, title, description, submit, options } = Array.isArray(
    config
  )
    ? { options: config }
    : config;
  options = options.map(o =>
    typeof o === "string" ? { value: o, label: o } : o
  );
  const form = input({
    type: "checkbox",
    title,
    description,
    submit,
    getValue: input => {
      if (input.length)
        return Array.prototype.filter
          .call(input, i => i.checked)
          .map(i => i.value);
      return input.checked ? input.value : false;
    },
    form: html`
      <form>
        ${options.map(({ value, label, color }) => {
          const d3_color = d3_6.color(color)
          const colorBlock = html`<span style="display: inline-block; background-color: ${d3_color}; width: 1em; height: 1em; border-radius: 1em"></span>`;
          const input = html`<input type=checkbox name=input ${
            (formValue || []).indexOf(value) > -1 ? "checked" : ""
          } style="vertical-align: baseline;" />`;
          input.setAttribute("value", value);
          const tag = html`<label style="display: inline-block; margin: 5px 10px 3px 0; font-size: 0.85em;">
           ${input}
           ${colorBlock}
           ${label}
          </label>`;
          return tag;
        })}
      </form>
    `
  });
  form.output.remove();
  return form;
}
)});
  main.variable(observer()).define(["md"], function(md){return(
md`### Bubble and Bar Charts`
)});
  main.variable(observer("d3_6")).define("d3_6", ["require"], function(require){return(
require("d3@6")
)});
  main.variable(observer("bubble_chart_pack")).define("bubble_chart_pack", ["d3_6","width","height"], function(d3_6,width,height){return(
data => d3_6.pack()
    .size([width - 2, height - 2])
    .padding(3)
  (d3_6.hierarchy({children: data})
    .sum(d => d.value))
)});
  main.variable(observer("bubble_chart_width")).define("bubble_chart_width", function(){return(
500
)});
  main.variable(observer("bubble_chart_height")).define("bubble_chart_height", ["bubble_chart_width"], function(bubble_chart_width){return(
bubble_chart_width
)});
  main.variable(observer("bubble_chart_format")).define("bubble_chart_format", ["d3_6"], function(d3_6){return(
d3_6.format(",d")
)});
  main.variable(observer("bubble_chart_color")).define("bubble_chart_color", ["d3_6","bubble_chart_data","d3"], function(d3_6,bubble_chart_data,d3){return(
d3_6.scaleOrdinal(bubble_chart_data.map(d => d.name), d3.schemeCategory10)
)});
  main.variable(observer("bubble_chart_files")).define("bubble_chart_files", ["FileAttachment"], function(FileAttachment){return(
[
  FileAttachment("nodes_provided_by.csv"),
  FileAttachment("nodes_node_type.csv"),
  FileAttachment("node_categories.csv"),
  FileAttachment("edges_edge_label.csv"),
  FileAttachment("edges_provided_by (1).csv"),
  FileAttachment("edges_target_type@1.csv"),
  FileAttachment("edges_association_type@1.csv")
].reduce((o, f) => (o[f.name] = f, o), {})
)});
  main.variable(observer("bubble_chart_data")).define("bubble_chart_data", ["d3_6","bubble_chart_files","bubble_chart_selection"], async function(d3_6,bubble_chart_files,bubble_chart_selection){return(
d3_6.csvParse(await bubble_chart_files[bubble_chart_selection].text(), ({value, id}) => ({name: id.split(".").pop(), title: id.replace(/\./g, "/"), group: id.split(".")[1], value: +value}))
)});
  main.variable(observer("bar_x")).define("bar_x", ["d3_6","bubble_chart_data","bar_margin","bar_width"], function(d3_6,bubble_chart_data,bar_margin,bar_width){return(
d3_6.scaleBand()
    .domain(d3_6.range(bubble_chart_data.length))
    .range([bar_margin.left, bar_width - bar_margin.right])
    .padding(0.1)
)});
  main.variable(observer("bar_y")).define("bar_y", ["d3_6","bubble_chart_data","bar_height","bar_margin"], function(d3_6,bubble_chart_data,bar_height,bar_margin){return(
d3_6.scaleLinear()
    .domain([0, d3_6.max(bubble_chart_data, d => d.value)]).nice()
    .range([bar_height - bar_margin.bottom, bar_margin.top])
)});
  main.variable(observer("bar_xAxis")).define("bar_xAxis", ["bar_height","bar_margin","d3_6","bar_x","bubble_chart_data"], function(bar_height,bar_margin,d3_6,bar_x,bubble_chart_data){return(
g => g
    .attr("transform", `translate(0,${bar_height - bar_margin.bottom})`)
    .call(d3_6.axisBottom(bar_x).tickFormat(i => bubble_chart_data[i].name).tickSizeOuter(0))
)});
  main.variable(observer("bar_yAxis")).define("bar_yAxis", ["bar_margin","d3_6","bar_y","bubble_chart_data"], function(bar_margin,d3_6,bar_y,bubble_chart_data){return(
g => g
    .attr("transform", `translate(${bar_margin.left},0)`)
    .call(d3_6.axisLeft(bar_y).ticks(null, bubble_chart_data.format))
    .call(g => g.select(".domain").remove())
    .call(g => g.append("text")
        .attr("x", -bar_margin.left)
        .attr("y", 10)
        .attr("fill", "currentColor")
        .attr("text-anchor", "start")
        .text(bubble_chart_data.bar_y))
)});
  main.variable(observer("bar_color")).define("bar_color", function(){return(
"steelblue"
)});
  main.variable(observer("bar_height")).define("bar_height", function(){return(
600
)});
  main.variable(observer("bar_width")).define("bar_width", function(){return(
1000
)});
  main.variable(observer("bar_margin")).define("bar_margin", function(){return(
{top: 30, right: 0, bottom: 110, left: 100}
)});
  main.variable(observer()).define(["md"], function(md){return(
md`### Wikipedia Graph`
)});
  main.variable(observer()).define(["html"], function(html){return(
html`<style>
  .reference {
    display: none
  }
</style>`
)});
  main.variable(observer("dot")).define("dot", ["require"], function(require){return(
require("@observablehq/graphviz@0.2")
)});
  main.variable(observer("baseUrl")).define("baseUrl", function(){return(
'https://en.wikipedia.org'
)});
  main.variable(observer("pick")).define("pick", function(){return(
(v, k) => [].concat(...v.map(d => d[k]))
)});
  main.variable(observer("domsToDiv")).define("domsToDiv", function(){return(
doms => {
  const container = document.createElement('div');
  doms.forEach(dom => (dom ? container.appendChild(dom) : null));

  return container;
}
)});
  main.variable(observer("cleanId")).define("cleanId", ["baseUrl"], function(baseUrl){return(
id => decodeURI(id.replace(`${baseUrl}/wiki/`, '').replace(/ /g, '_'))
)});
  main.variable(observer("lexer")).define("lexer", function(){return(
text => text.split(/[_ ]/g)
)});
  main.variable(observer("wrapText")).define("wrapText", ["lexer"], function(lexer){return(
(text, len = 15) => {
  const words = lexer(text);
  let lines = '';
  let count = 0;
  for (let word of words) {
    if (count + word.length >= len) {
      lines += `\n${word} `;
      count = word.length;
    } else {
      lines += `${word} `;
      count += word.length;
    }
  }
  return lines.trim();
}
)});
  main.variable(observer("qs")).define("qs", function(){return(
params =>
  Object.keys(params)
    .map(key => `${key}=${params[key]}`)
    .join('&')
)});
  main.variable(observer("loadArticle")).define("loadArticle", ["baseUrl","qs"], function(baseUrl,qs){return(
id =>
  fetch(
    `${baseUrl}/w/api.php?${qs({
      format: 'json',
      origin: '*',
      action: 'parse',
      prop: 'text',
      redirects: true,
      page: id,
      section: 0
    })}`
  ).then(response => response.json())
)});
  main.variable(observer("loadArticles")).define("loadArticles", ["loadArticle","cleanId"], function(loadArticle,cleanId){return(
links =>
  Promise.all(links.map(link => loadArticle(cleanId(link))))
)});
  main.variable(observer("domParser")).define("domParser", ["DOMParser"], function(DOMParser){return(
new DOMParser()
)});
  main.variable(observer("addBaseToLinks")).define("addBaseToLinks", ["baseUrl"], function(baseUrl){return(
text => text.replace(/href="/g, 'href="' + baseUrl)
)});
  main.variable(observer("constructDom")).define("constructDom", ["domParser"], function(domParser){return(
text => domParser.parseFromString(text, 'text/html')
)});
  main.variable(observer("filterLinks")).define("filterLinks", function(){return(
links =>
  links.filter(
    link =>
      link.indexOf('#cite') === -1 &&
      link.indexOf('upload.') === -1 &&
      link.indexOf('File:') === -1 &&
      link.indexOf('.php') === -1 &&
      link.indexOf('#') === -1 &&
      link.indexOf('.orghttp') === -1 &&
      link.indexOf('Help:') === -1
  )
)});
  main.variable(observer("selectIntro")).define("selectIntro", function(){return(
dom =>
  Array.from(
    dom.querySelectorAll('.mw-parser-output > p:not(.mw-empty-elt)')
  ).find(el => !el.querySelector('#coordinates'))
)});
  main.variable(observer("importNode")).define("importNode", function(){return(
dom => document.importNode(dom, true)
)});
  main.variable(observer("extractLinks")).define("extractLinks", function(){return(
dom =>
  Array.from(dom.querySelectorAll('a')).map(link => link.href)
)});
  main.variable(observer("processResponse")).define("processResponse", ["cleanId","importNode","selectIntro","constructDom","addBaseToLinks","filterLinks","extractLinks"], function(cleanId,importNode,selectIntro,constructDom,addBaseToLinks,filterLinks,extractLinks){return(
response => {
  if (!response || response.error || !response.parse) {
    return {
      id: '',
      intro: null,
      links: []
    };
  }
  try {
    const id = cleanId(response.parse.title);
    const intro = importNode(
      selectIntro(constructDom(addBaseToLinks(response.parse.text['*'])))
    );
    const links = filterLinks(extractLinks(intro));

    return {
      id,
      intro,
      links,
      ...response.parse
    };
  } catch (e) {
    return {
      id: '',
      intro: null,
      links: []
    };
  }
}
)});
  main.variable(observer("rootArticle")).define("rootArticle", ["loadArticles","cleanId","id","processResponse"], async function(loadArticles,cleanId,id,processResponse){return(
(await loadArticles([cleanId(id)])).map(processResponse)
)});
  main.variable(observer("secondArticles")).define("secondArticles", ["loadArticles","pick","rootArticle","processResponse"], async function(loadArticles,pick,rootArticle,processResponse){return(
(await loadArticles(pick(rootArticle, 'links'))).map(
  processResponse
)
)});
  main.variable(observer("thirdArticles")).define("thirdArticles", function(){return(
[]
)});
  main.variable(observer("articles")).define("articles", ["rootArticle","secondArticles"], function(rootArticle,secondArticles){return(
(rootArticle ? rootArticle : []).concat(
  secondArticles ? secondArticles : []
  //, thirdArticles ? thirdArticles : []
)
)});
  main.variable(observer("redirects")).define("redirects", ["pick","articles"], function(pick,articles){return(
pick(articles, 'redirects').filter(d => d)
)});
  main.variable(observer("edges")).define("edges", ["articles","cleanId","redirects"], function(articles,cleanId,redirects){return(
[]
  .concat(
    ...articles.map(article =>
      article.links.map(link => [article.id, cleanId(link)])
    )
  )
  .map(edge =>
    edge.map(v =>
      cleanId(
        (redirects.find(redirect => cleanId(redirect.from) === v) || { to: v })
          .to
      )
    )
  )
)});
  main.variable(observer()).define(["md"], function(md){return(
md`## Force directed graph`
)});
  main.variable(observer("d3")).define("d3", ["require"], function(require){return(
require("d3@5")
)});
  main.variable(observer("drag")).define("drag", ["d3"], function(d3){return(
simulation => {
  
  function dragstarted(d) {
    if (!d3.event.active) simulation.alphaTarget(0.3).restart();
    
    // setting the fx values will "pin" the nodes to this position
    d.fx = d.x; 
    d.fy = d.y;
  }
  
  function dragged(d) {
    d.fx = d3.event.x;
    d.fy = d3.event.y;
  }
  
  function dragended(d) {
    if (!d3.event.active) simulation.alphaTarget(0);
    
    // if these are null, the simulation will relocate them
    // d.fx = null; 
    // d.fy = null;
  }
  
  return d3.drag()
      .on("start", dragstarted)
      .on("drag", dragged)
      .on("end", dragended);
}
)});
  main.variable(observer("color")).define("color", ["d3"], function(d3)
{
  const scale = d3.scaleOrdinal(d3.schemeCategory10);
  return d => scale(d.group);
}
);
  main.variable(observer("height")).define("height", function(){return(
400
)});
  main.variable(observer("width")).define("width", function(){return(
400
)});
  main.variable(observer("colorScale")).define("colorScale", ["d3"], function(d3){return(
d3.scaleOrdinal() //=d3.scaleOrdinal(d3.schemeSet2)
    .domain(["Protein|Gene", "Gene", "Drug",
       "PhenotypicFeature"])
    .range(['#ff9e6d', '#86cbff', '#c2e5a0','#fff686'])
)});
  main.variable(observer("margin")).define("margin", function(){return(
{top: 30, right: 80, bottom: 5, left: 5}
)});
  main.define("initial search_term", function(){return(
""
)});
  main.variable(observer("mutable search_term")).define("mutable search_term", ["Mutable", "initial search_term"], (M, _) => new M(_));
  main.variable(observer("search_term")).define("search_term", ["mutable search_term"], _ => _.generator);
  main.variable(observer("force_graph_files")).define("force_graph_files", ["FileAttachment"], function(FileAttachment){return(
[
  FileAttachment("albuterol.json"),
  FileAttachment("acetaminophen-test@2.json"),
  FileAttachment("acetaminophen-big.json"),
  FileAttachment("ubql1_human.json"),
  FileAttachment("ubql1_human_small@1.json")
].reduce((o, f) => (o[f.name] = f, o), {})
)});
  main.variable(observer("force_graph_data")).define("force_graph_data", ["force_graph_files","force_graph_selection"], function(force_graph_files,force_graph_selection){return(
force_graph_files[force_graph_selection].json()
)});
  return main;
}
